package atomicstryker.infernalmobs.common.network;

import atomicstryker.infernalmobs.common.InfernalMobsCore;
import atomicstryker.infernalmobs.common.MobModifier;
import atomicstryker.infernalmobs.common.network.NetworkHelper.IPacket;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.FMLCommonHandler;

public class MobModsPacket implements IPacket
{
    
    private String stringData;
    private int entID;
    private byte sentFromServer;

    public MobModsPacket() {}
    
    public MobModsPacket(String str, int i, byte ir)
    {
        stringData = str;
        entID = i;
        sentFromServer = ir;
    }

    @Override
    public void writeBytes(ChannelHandlerContext ctx, ByteBuf bytes)
    {
        bytes.writeByte(sentFromServer);
        bytes.writeShort(stringData.length());
        for (char c : stringData.toCharArray()) bytes.writeChar(c);
        bytes.writeInt(entID);
    }

    @Override
    public void readBytes(ChannelHandlerContext ctx, ByteBuf bytes)
    {
        sentFromServer = bytes.readByte();
        short len = bytes.readShort();
        char[] chars = new char[len];
        for (int i = 0; i < len; i++) chars[i] = bytes.readChar();
        stringData = String.valueOf(chars);
        entID = bytes.readInt();
        FMLCommonHandler.instance().getMinecraftServerInstance().addScheduledTask(new ScheduledCode());
        
        if (sentFromServer != 0)
        {
            FMLClientHandler.instance().getClient().addScheduledTask(new ScheduledCode());
        }
        else
        {
            FMLCommonHandler.instance().getMinecraftServerInstance().addScheduledTask(new ScheduledCode());
        }
    }
    
    class ScheduledCode implements Runnable
    {
        @Override
        public void run()
        {
            if (sentFromServer != 0)
            {
                // so we are on client now
                InfernalMobsCore.proxy.onMobModsPacketToClient(stringData, entID);
            }
            else
            {
                // else we are on serverside
                EntityPlayerMP p = FMLCommonHandler.instance().getMinecraftServerInstance().getPlayerList().getPlayerByUsername(stringData);
                if (p != null)
                {
                    Entity ent = p.worldObj.getEntityByID(entID);
                    if (ent != null && ent instanceof EntityLivingBase)
                    {
                        EntityLivingBase e = (EntityLivingBase) ent;
                        MobModifier mod = InfernalMobsCore.getMobModifiers(e);
                        if (mod != null)
                        {
                            stringData = mod.getLinkedModNameUntranslated();
                            InfernalMobsCore.instance().networkHelper.sendPacketToPlayer(new MobModsPacket(stringData, entID, (byte)1), p);
                            InfernalMobsCore.instance().sendHealthPacket(e);
                        }
                    }
                }
            }
        }
    }

}
